<?php

// ***************** CONFIGURATION *****************

// Information du cPanel
 $cputilisateur = "UTILISTEUR"; // Nom d'utilisateur du cPanel
 $cpmotdepass = "MOT DE PASSE"; // Mot de passe du cPanel
 $domaine = "domaine.com"; // Le nom de domaine du site Web sans http et www
 $skin = "x3"; // Le thème d'affichage utilisé par cPanel (obligatoire)

// Information sur la sauvegarde
 $ftpmode = "homedir"; // FTP mode ("homedir" pour une complète, "ftp" pour active, "passiveftp" pour passive)
// Scan antivirus (1 = Activé || 0 = Désactivé)
 $antivirus = 0;

// Durée de conservation de la sauvegarde sur le FTP
 $jours=3;

// Recevoir un mail de notification une fois la sauvegarde prête
 $emailnotification = "adresse@monsite.com";

// Sécurisé ou non avec https
 $securise = 1; // Indiquez 1 pour SSL
// Vérification du bon fonctionnement du script
 $test = 1;

 // ***************** A NE PAS MODIFIER *****************

if ($securise) { // Si sécurisé
 $url = "ssl://".$domaine; // Domaine
 $port = 2083; // Port 2083
 } else { // Sinon
 $url = $domaine;; // Domaine
 $port = 2082; // Port 2082
 }
$fsocket = fsockopen($url,$port); // Ouverture via fsockopen
 if (!$fsocket) // Si on arrive pas a lire
 {
 echo "Impossible d'ouvrir le socket ... \n"; // Affiche une erreur
 exit; // On stop
 }

// Encode le mot de passe et utilisateur
 $authstr = $cputilisateur.":".$cpmotdepass;
 $pass = base64_encode($authstr);

// Le paramètre transmis en GET
 $params = "dest=$ftpmode&email=$emailnotification&server=&user=&pass=&port=&rdir=&submit=Generate Backup";

// Envoie un "POST" au cPanel
 fputs($fsocket,"POST /frontend/".$skin."/backup/dofullbackup.html?".$params." HTTP/1.0\r\n");
 fputs($fsocket,"Host: $domaine\r\n");
 fputs($fsocket,"Authorization: Basic $pass\r\n");
 fputs($fsocket,"Connection: Close\r\n");
 fputs($fsocket,"\r\n");

// Reçoit la réponce
 while (!feof($fsocket)) {
 $response = fgets($fsocket,4096); // Reçoit ligne par ligne
 if ($test) // Si on est en mode debug
 echo $response; // On affiche
 }
 fclose($fsocket);
//Antivirus CLAMAV !?
 if($antivirus==1)
 {
 $fsocket = fsockopen($url,$port);
 if (!$fsocket) { echo "Impossible d'ouvrir le socket ... \n"; exit; }

 // Encode le mot de passe et utilisateur (Anti-Virus)
 $authstr = $cputilisateur.":".$cpmotdepass;
 $pass = base64_encode($authstr);

 // Envoie un "POST" au cPanel
 fputs($fsocket,"GET /frontend/".$skin."/clamavconnector/scanner.html?scanpath=home HTTP/1.0\r\n");
 fputs($fsocket,"Host: $domaine\r\n");
 fputs($fsocket,"Authorization: Basic $pass\r\n");
 fputs($fsocket,"Connection: Close\r\n");
 fputs($fsocket,"\r\n");

 // Reçoit la réponse
 while (!feof($fsocket)) {
 $response = fgets($fsocket,4096);
 if ($test) echo $response;
 }
 fclose($fsocket);
 }

// Supprime les vielles sauvegardes (X jours)
 foreach (glob("*.tar.gz") as $filename) { // Pour tout les *.tar.gz qui se trouve dans le /
 if ((time() - filemtime($filename) >= $jours*86400)) //86400sec = 1 jour
 unlink("$filename"); // Suppression
 }
 ?>